# -*- coding: utf-8 -*-
## wirkungsdiagramm.py
## © Claus Albowski

## Importe:
import platform
versionsNummer=platform.python_version()[0]
if versionsNummer=='2':
    from Tkinter import *
    import tkFileDialog as fileDialog
else:
    from tkinter import *
    import tkinter.filedialog as fileDialog

from export.wirkungsModell import *
from export.wirkungsFensterElemente import *

class WDController(object):
    derController=None
    @staticmethod
    def GibWDController(app):
        if WDController.derController==None: WDController.derController=WDController(app)
        return WDController.derController
    
    def __init__(self, app):
        '''Singleton - aber nicht erzwungen
        verwaltet die Verbindung zwischen Objekten (Faktoren und Wirkungen)
        und ihren CanvasElementen'''
        self.__faktoren=dict()   # {name:(faktor, element)}
        self.__wirkungen=dict()  # {name:(wirkung, element)}

    def LoescheAlle(self,zf):
        CanvasElement.LoescheAlle(zf)
        wirkungen,faktoren=[],[]
        for name in self.__wirkungen: wirkungen.append(name)
        for name in wirkungen: self.LoescheWirkung(name)
        for name in self.__faktoren: faktoren.append(name)
        for name in faktoren: self.LoescheFaktor(name)
    def IstLeer(self): return (len(self.__faktoren)==0 and len(self.__wirkungen)==0)
    def GibFaktorDaten(self,name): return self.__faktoren.get(name)
    def NeuerFaktor(self, name, faktor, element):
        if name in self.__faktoren.keys(): return False
        self.__faktoren.update({name:(faktor, element)})
        return True
    def LoescheFaktor(self, name):
        if not(name in self.__faktoren.keys()): return None
        return self.__faktoren.pop(name)
    def AendereFaktor(self, zf, alterName, neuerName):
        fa,fe=self.GibFaktorDaten(alterName)
        pos=fe.GibPosition()
        CanvasElement.LoescheElement(zf, alterName)
        self.LoescheFaktor(alterName)
        fe=FaktorElement(zf, neuerName, pos)
        self.NeuerFaktor(neuerName, fa, fe)
    def LoescheFaktorUndWirkungen(self, zf, name):
        '''Loescht auch die zugehoerigen Wirkungen'''
        if not(name in self.__faktoren.keys()): return
        wirkNamen=[]
        for wirkName in self.__wirkungen:
            if name in wirkName:
                wirkNamen.append(wirkName)
        for wirkName in wirkNamen:
            self.LoescheWirkung(wirkName)
            CanvasElement.LoescheElement(zf,wirkName)
        CanvasElement.LoescheElement(zf, name)
        self.LoescheFaktor(name)
        
    def NeueWirkung(self, name, wirkung, element):
        if name in self.__wirkungen.keys(): return False
        self.__wirkungen.update({name:(wirkung, element)})
        return True
    def LoescheWirkung(self, name):
        if not(name in self.__wirkungen.keys()): return None
        return self.__wirkungen.pop(name)
    def GibWirkungsDaten(self,name):
        wi,we=self.__wirkungen.get(name)
        return name,wi,we
    def GibAlleWirkZu(self, faktorName):
        passende=[]
        for name in self.__wirkungen:
            if faktorName in name:
                passende.append(self.GibWirkungsDaten(name))
        return passende
    def AendereWirkungenZu(self, zf, alt, neu):
        alle=self.GibAlleWirkZu(alt)
        for dat in alle:
            von,pfeil,auf=dat[0].partition('->')
            art=dat[2].GibArt()
            if von==alt: von=neu
            elif auf==alt: auf=neu
            self.LoescheWirkung(dat[0])
            CanvasElement.LoescheElement(zf,dat[0])
            wi=Wirkung.HatWirkung(von, auf)
            we=WirkungElement(zf, von, auf, art)
            self.NeueWirkung(we.GibTag(),wi,we)
    def LoescheWirkungElement(self, zf, von, auf):
        name=von+'->'+auf
        CanvasElement.LoescheElement(zf,name)
        self.LoescheWirkung(name)
    def AendereBogenOrientierung(self, zf,tag):
        wi,we=self.__wirkungen.get(tag)
        von,auf,art,bo=we.GibVon(),we.GibAuf(),we.GibArt(),we.GibBogenOrientierung()
        bo*=-1
        CanvasElement.LoescheElement(zf,tag)
        self.LoescheWirkung(tag)
        we=WirkungElement(zf,von,auf,art,bo)
        self.NeueWirkung(tag,wi,we)
    def TypFestlegen(self,zf,faktorName,typ,von=None,auf=None):
        if typ=='Fluss':
            WirkungsModell.GibWirkungsModell(self).SetzeTyp(faktorName, 'Fluss',von,auf)
        else:
            WirkungsModell.GibWirkungsModell(self).SetzeTyp(faktorName, typ)
        elID=self.__faktoren[faktorName][1].GibID()
        if typ=='Bestand': zf.itemconfigure(elID,outline='light gray')
        elif typ=='Fluss': zf.itemconfigure(elID,outline='#88f')
        elif typ=='Parameter': zf.itemconfigure(elID,outline='#f88')
        elif typ=='Zwischengroesse': zf.itemconfigure(elID,outline='#8f8')
