# -*- coding: utf-8 -*-
## modellfensterElemente.py
## © Claus Albowski
import platform
import math
versionsNummer=platform.python_version()[0]
if versionsNummer=='3': from tkinter import *
else: from Tkinter import *

class CanvasElement(object):
    '''Alle Hauptelemente werden im Dictionary "nameUndElement" abgespeichert.
    Das Loeschen erfolgt dann ueber das tag.'''    

    @staticmethod
    def ObjektZuTag(tag):
        return CanvasElement.nameUndElement.get(tag)
    
    @staticmethod
    def NeuesElement(tag, element):
        return CanvasElement.nameUndElement.update({(tag,element)})

    @staticmethod
    def AendereNamen(zf, alterName, neuerName):
        '''ersetzt das Objekt mit dem bisherigen Namen
        durch eines mit dem neuen Namen;
        Problem: Auch die Fluesse und Wirkungen muessen
        gegebenenfalls angepasst werden.'''
        dasObjekt=CanvasElement.ObjektZuTag(alterName)
        typ=dasObjekt.__class__
        if typ in (BestandsElement,ParameterElement,ZwischengroesseElement):
            # Position sichern
            x,y=dasObjekt.GibPosition()        
        if typ in (BestandsElement,ParameterElement,ZwischengroesseElement):
            CanvasElement.LoescheElement(zf, dasObjekt)
            typ(zf, neuerName, (x,y))
            # Fluesse informieren & Wirkungen neu zeichnen
            alleTags=[]
            for tag in CanvasElement.nameUndElement:
                alleTags.append(tag)
            for tag in alleTags:
                element=CanvasElement.ObjektZuTag(tag)
                if element.__class__==FlussElement:
                    von,auf=element.GibVonAuf()
                    if alterName==von:
                        element.UpdateNamen(neuerName,auf)
                    elif alterName==auf:
                        element.UpdateNamen(von,neuerName)
                if element.__class__==WirkungElement:
                    if alterName==element.von:
                        auf=element.auf
                        CanvasElement.LoescheElement(zf, element)
                        WirkungElement(zf, neuerName, auf)
                    elif alterName==element.auf:
                        von=element.von
                        CanvasElement.LoescheElement(zf, element)
                        WirkungElement(zf, von, neuerName)
            return
        if typ in [FlussElement]:
            ## Flussdaten merken
            flussVon,flussAuf=dasObjekt.GibVonAuf()
            ## dann loeschen
            CanvasElement.LoescheElement(zf, dasObjekt)
            ## alle Wirkungen merken
            alteWirkungsTags=[]
            neueWirkungsTags=[]
            for tag in CanvasElement.nameUndElement:
                element=CanvasElement.ObjektZuTag(tag)
                if element.__class__==WirkungElement:
                    von,pfeil,auf=tag.partition('->')
                    if von==alterName:
                        alteWirkungsTags.append(tag)
                        neueWirkungsTags.append(neuerName+'->'+auf)
                    if auf==alterName:
                        alteWirkungsTags.append(tag)
                        neueWirkungsTags.append(von+'->'+neuerName)
            for tag in alteWirkungsTags: 
                CanvasElement.LoescheElement(zf, CanvasElement.ObjektZuTag(tag))
            FlussElement(zf, neuerName, flussVon, flussAuf)
            ## neue WirkungElemente einbauen
            for tag in neueWirkungsTags:
                von,pfeil,auf=tag.partition('->')
                WirkungElement(zf, von, auf)

    @staticmethod
    def LoescheElement(zf, element):
        if not element: return #bereits geloescht
        try:
            tag=zf.gettags(element.ID)[0]
        except IndexError as e:
            return
        if element.textID!=None:
            zf.delete(element.textID)
        CanvasElement.alleFigurenIDs.remove(element.ID)
        CanvasElement.nameUndElement.pop(tag)
        zf.delete(tag)

    @staticmethod
    def LoescheAlle(zf):
        alle=[]
        for tag in CanvasElement.nameUndElement:
            alle.append(CanvasElement.ObjektZuTag(tag))
        for element in alle:
            CanvasElement.LoescheElement(zf,element)
            
    @staticmethod
    def GibAlleFaktorNamenMitPosition():
        daten = []
        for tag in CanvasElement.nameUndElement:
            dasObjekt=CanvasElement.nameUndElement[tag]
            typ=dasObjekt.__class__
            if typ in (BestandsElement,ParameterElement,ZwischengroesseElement):
                # Position sichern
                x,y=dasObjekt.GibPosition()        
                daten.append((tag,x,y))
        return daten

    @staticmethod
    def IstFigurID(ID):
        return ID in CanvasElement.alleFigurenIDs
    
    @staticmethod
    def IstFigurTag(tag):
        return tag in CanvasElement.nameUndElement.keys()

    @staticmethod
    def AktualisiereWirkung(zf,von,auf,orBog=1):
        element=CanvasElement.ObjektZuTag(von+'->'+auf)
        CanvasElement.LoescheElement(zf,element)
        wi=WirkungElement(zf, von, auf,orBog)

    @staticmethod
    def AktualisiereWirkungenAuf(zf,auf):
        namen=[] #echte Kopie der Namen
        for name in CanvasElement.nameUndElement:
            namen.append(name)
        for name in namen:
            element=CanvasElement.nameUndElement[name]
            if element.__class__==WirkungElement:
                ##print(element.von,auf,element.auf==auf)
                if element.auf==auf:
                    CanvasElement.AktualisiereWirkung(zf,element.von,auf)

    @staticmethod
    def AktualisiereWirkungenVon(zf,von):
        namen=[] #echte Kopie der Namen
        for name in CanvasElement.nameUndElement:
            namen.append(name)
        for name in namen:
            element=CanvasElement.nameUndElement[name]
            if element.__class__==WirkungElement:
                if element.von==von:
                    CanvasElement.AktualisiereWirkung(zf,von,element.auf)

    @staticmethod
    def AktualisiereFluss(zf,name):
        element=CanvasElement.ObjektZuTag(name)
        von,auf=element.GibVonAuf()
        quelleSenke=element.GibQuelleSenke()
        CanvasElement.LoescheElement(zf,element)
        fl=FlussElement(zf, name, von, auf)
        fl.SetzeQuelleSenke(quelleSenke)
        
    @staticmethod
    def AktualisiereAllePfeile(zf):
        '''erst die Flüsse, dann die Wirkungen'''
        namen=[]
        for name in CanvasElement.nameUndElement:
            namen.append(name)
        for name in namen:
            element=CanvasElement.nameUndElement[name]
            if element.__class__==FlussElement:
                CanvasElement.AktualisiereFluss(zf,name)
        for name in CanvasElement.nameUndElement:
            namen.append(name)
        for name in namen:
            if '->' in name:
                element=CanvasElement.nameUndElement[name]
                orBog=element.GibBogenOrientierung()
                von,pfeil,auf=name.partition('->')
                CanvasElement.AktualisiereWirkung(zf,von,auf,orBog)

    fg,bg='black','white'
    @staticmethod
    def Setze_FG_BG(fg,bg):
        CanvasElement.fg=fg
        CanvasElement.bg=bg
    
    # Fuellung Bestand, Parameter, Zwischengrosse, Fluss, Wirkung
    farben=['','','', '',''] # Standard
    ##farben=['yellow','#f33','gray', '#3f3',''] # Beispielwerte auf schwarz
    ##farben=['yellow','#fee','light gray', '#dfd',''] # Beispielwerte auf weiss
    @staticmethod
    def FarbenFestlegen(farbliste):
        if len(farbliste)!=5: return False
        CanvasElement.farben=farbliste
        if len(CanvasElement.nameUndElement)==0: return # noch keine Elemente
        zf=CanvasElement.nameUndElement[list(CanvasElement.nameUndElement.keys())[0]].zf
        for name in CanvasElement.nameUndElement:
            element=CanvasElement.nameUndElement[name]
            if element.__class__==BestandsElement:
                zf.itemconfigure(name,fill=farbliste[0])
                zf.itemconfigure(element.textID,fill=CanvasElement.fg)
            elif element.__class__==ParameterElement:
                zf.itemconfigure(name,fill=farbliste[1])
                zf.itemconfigure(element.textID,fill=CanvasElement.fg)
            elif element.__class__==ZwischengroesseElement:
                zf.itemconfigure(name,fill=farbliste[2])
                zf.itemconfigure(element.textID,fill=CanvasElement.fg)
            elif element.__class__==FlussElement:
                zf.itemconfigure(element.ventil_id,fill=farbliste[3])
                zf.itemconfigure(element.textID,fill=CanvasElement.fg)
            elif element.__class__==WirkungElement:
                zf.itemconfigure(name,fill=farbliste[4])
    
    nameUndElement=dict()
    alleFigurenIDs = []

    ##### K O N S T R U K T O R #######################
    def __init__(self, zf, ID, pos, endPos, name=None):
        self.zf=zf
        self.ID=ID ## TODO wird das ueberhaupt gebraucht ???
        CanvasElement.alleFigurenIDs.append(ID)
        self.textID=None
        self.name=name
        self.x,self.y=pos
        self.xe,self.ye=endPos
        if name!=None:
            CanvasElement.NeuesElement(name,self)

    def GibID(self): return self.ID
    def GibTag(self): return self.name
    def GibPosition(self): return self.x,self.y
    def GibEndPosition(self): return self.xe,self.ye
    def BestimmeKoordinaten(self, pos, name):
        x,y=pos
        l=max(10+len(name)*11,60)
        xe,ye=pos[0]+l, pos[1]+30
        return x,y,xe,ye
    def Mitte(self, koordinaten):
        x,y,xe,ye=koordinaten
        return int((x+xe)/2),int((y+ye)/2)
    def FG(self): return CanvasElement.fg
    def BG(self): return CanvasElement.bg

class BestandsElement(CanvasElement):
    def __init__(self, zf, name, pos=(10,10)):
        '''Zeichenflaeche und eindeutigen Namen uebergeben'''
        x,y,xe,ye=self.BestimmeKoordinaten(pos, name)
        ID=zf.create_rectangle(x,y, xe,ye, width=2, tag=name,
                               fill=CanvasElement.farben[0],
                               outline=self.FG())
        CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
        if name!=None:
            xm,ym=self.Mitte((self.x,self.y,self.xe,self.ye))
            self.textID=zf.create_text(xm,ym, text=name, tag=name,
                                       fill=self.FG(),font="Sans 11 bold")
            
class ParameterElement(CanvasElement):
    def __init__(self, zf, name, pos=(10,10)):
        '''Zeichenflaeche und eindeutigen Namen uebergeben'''
        x,y=(pos[0]-12.5,pos[1]-12.5)  # Kreisdurchmesser, nicht Laenge des Namen
        xe,ye=(pos[0]+12.5,pos[1]+12.5)
        xk,yk=pos
        ID=zf.create_oval(xk,yk,xk+25,yk+25, tag=name, width=2,
                          fill=CanvasElement.farben[1],
                          outline=self.FG())
        CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
        if name!=None:
            xm,ym=self.Mitte((self.x,self.y,self.xe,self.ye))
            xm,ym=xm+10,ym+35
            self.textID=zf.create_text(xm,ym, text=name, tag=name,
                                       fill=self.FG(), font="Sans 11 bold")
            
class ZwischengroesseElement(CanvasElement):
    def __init__(self, zf, name, pos=(10,10)):
        '''Zeichenflaeche und eindeutigen Namen uebergeben'''
        x,y=(pos[0]-12.5,pos[1]-12.5)  # Kreisdurchmesser, nicht Laenge des Namen
        xe,ye=(pos[0]+12.5,pos[1]+12.5)
        xk,yk=pos
        ID=zf.create_oval(xk,yk,xk+25,yk+25, tag=name, width=2,
                          fill=CanvasElement.farben[2],
                          outline=self.FG())
        CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
        if name!=None:
            xm,ym=self.Mitte((self.x,self.y,self.xe,self.ye))
            xm,ym=xm+10,ym+30
            self.textID=zf.create_text(xm,ym, text=name, tag=name,
                                       fill=self.FG(), font="Sans 11 bold")
            
class WirkungElement(CanvasElement):
    def __init__(self, zf, von, auf, bogenOrientierung=1):
        '''Zeichenflaeche und eindeutige Namen uebergeben'''
        self.orBog=bogenOrientierung # Orientierung des Pfeilbogens
        self.von,self.auf=von, auf # sichern fuer AendereNamen
        x,y=self.Mitte(zf.bbox(von))
        xe,ye=self.Mitte(zf.bbox(auf))
        if CanvasElement.ObjektZuTag(auf).__class__==FlussElement:
            # "auf" fuer Darstellung ersetzen durch das Ventil
            a,b,xe,ye=zf.coords(CanvasElement.ObjektZuTag(auf).GibVentil_id())
            xe,ye=xe-10,ye #zum Ventil
            if y>ye+50: ye+=10 #von unten auf den Namen
            else: # von oben auf das Ventilsymbol
                if self.orBog>0.5:
                    xe-=5
        if CanvasElement.ObjektZuTag(auf).__class__==ZwischengroesseElement:
            #Keine Wirkungen auf Parameter
            if y>=ye+10: ye+=5 #von unten auf den Namen
        if abs(y-ye)<20:
            if x>xe: verY=-self.orBog*10
            else: verY=self.orBog*10
            y,ye=y+verY,ye+verY
        xm,ym=self.Mitte((x,y,xe,ye))
        ## Ueberschneidung vermeiden
        if (xm-x)>0: dx=min(0.24*(xm-x),12)
        else: dx=max(0.24*(xm-x),-12)
        if (ym-y)>0: dy=min(0.24*(ym-y),12)	
        else: dy=max(0.24*(ym-y),-12)
        x,y = x+dx,y+2*dy
        xe,ye = xe-dx,ye-dy
        self.ve=0.3 # VersatzFaktor fuer orthogonal       
        dx,dy=self.orBog*(1+int(self.ve*(ye-y))),self.orBog*(-1-int(self.ve*(xe-x)))
        if CanvasElement.farben[4]=='': farbe=self.FG()
        else: farbe=CanvasElement.farben[4]
        ID=zf.create_line(x,y,xm-dx,ym-dy,xe,ye, arrow=LAST, arrowshape=(12,18,6),
                          smooth=True, width=2, tag=von+'->'+auf,
                          fill=farbe)
        CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), None)
        CanvasElement.NeuesElement(von+'->'+auf,self)
        
    def GibBogenOrientierung(self): return self.orBog
        
class FlussElement(CanvasElement):
    def __init__(self, zf, name, von, auf, quelleSenke=None):
        '''zeichenflaeche und eindeutige Namen uebergeben
        quelleSenke enthaelt ggf deren Koordinaten'''
        if (von==auf): return None # fehlerhafte Auswahl
        ### Unterscheidung entweder von=='' oder auf=='' notwendig:
        self.von,self.auf=von,auf
        self.quelleSenke=None
        self.ventil_id=None
        pfeiltyp=None
        if von=="Quelle":           # nur beim Initialisieren
            x0,y0,x1,y1=zf.bbox(self.auf)
            b=max(100,len(name)*9)
            x,y=x0-20-b,(y0+y1)/2
            xe,ye=x0,(y0+y1)/2
            self.von="Quelle_"+name
            if quelleSenke!=None: x,y=quelleSenke
            self.quelleSenke=QuelleSenke(zf,self.von,x,y+3,True)
            if quelleSenke==None: pfeiltyp='einfach'
        if auf=="Senke":
            x0,y0,x1,y1=zf.bbox(self.von)
            b=max(100,len(name)*9)
            x,y=x1,(y0+y1)/2
            xe,ye=x1+20+b,(y0+y1)/2
            self.auf="Senke_"+name
            if quelleSenke!=None: xe,ye=quelleSenke
            self.quelleSenke=QuelleSenke(zf,self.auf,xe,ye+3,False)
            if quelleSenke==None: pfeiltyp='einfach'
        if von!="Quelle":
            x,y=self.Mitte(zf.bbox(self.von)) # Position "von"
        if auf!="Senke":
            xe,ye=self.Mitte(zf.bbox(self.auf)) # Position "auf"

        ## Verzweigung in die Faelle
        if (x<xe) and (abs(y-ye)<=30): pfeiltyp='einfach'
        if pfeiltyp=='einfach': # Standardpfeil nach rechts
            if von!="Quelle": x=zf.bbox(self.von)[2] # links rechten Rand waehlen
            if auf!="Senke": xe=zf.bbox(self.auf)[0] # rechts linken Rand waehlen
            ID=self.erzeugeFlussSymbol(zf, x, y, xe, ye, name)
            CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
                
        ### Spezialfaelle
        ## "auf" liegt links unterhalb ueberlagernd
        elif (self.aufLinksDeckend(zf.bbox(self.von),zf.bbox(self.auf)) and\
              self.aufUnter(zf.bbox(self.von),zf.bbox(self.auf))):
            bV,bA=zf.bbox(self.von),zf.bbox(self.auf)
            xm=(bV[0]+bA[2])/2
            x,y=xm+20,bV[3] # Platz fuer Ventil lassen
            xe,ye=xm-20,bA[1]
            ID=self.erzeugeFlussSenkrecht(zf, x, y, xe, ye, name)
            CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
        ## "auf" liegt links oberhalb ueberlagernd
        elif self.aufLinksDeckend(zf.bbox(self.von),zf.bbox(self.auf)):
            bV,bA=zf.bbox(self.von),zf.bbox(self.auf)
            xm=(bV[0]+bA[2])/2
            x,y=xm+20,bV[1] # Platz fuer Ventil lassen
            xe,ye=xm-20,bA[3]
            ID=self.erzeugeFlussSenkrecht(zf, x, y, xe, ye, name)
            CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
        ## "auf" liegt rechts unterhalb ueberlagernd
        elif (self.aufRechtsDeckend(zf.bbox(self.von),zf.bbox(self.auf)) and\
              self.aufUnter(zf.bbox(self.von),zf.bbox(self.auf))):
            bV,bA=zf.bbox(von),zf.bbox(self.auf)
            xm=(bV[2]+bA[0])/2
            if von!='Quelle': x,y=xm-20,bV[3] # Platz fuer Ventil lassen
            if auf!='Senke': xe,ye=xm+20,bA[1]
            ID=self.erzeugeFlussSenkrecht(zf, x, y, xe, ye, name)
            CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
        ## "auf" liegt rechts oberhalb ueberlagernd
        elif self.aufRechtsDeckend(zf.bbox(self.von),zf.bbox(self.auf)):
            bV,bA=zf.bbox(self.von),zf.bbox(self.auf)
            xm=(bV[2]+bA[0])/2
            if von!='Quelle': x,y=xm-20,bV[1] # Platz fuer Ventil lassen
            if auf!='Senke': xe,ye=xm+20,bA[3]           
            ID=self.erzeugeFlussSenkrecht(zf, x, y, xe, ye, name)
            CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
        ## einfacher Winkel rechts
        elif (x<xe):
            ## (x,y) und (xe,ye) sind die Positionen der Mitten
            if y<ye: y=zf.bbox(self.von)[3] # nach unten rechts
            else: y=zf.bbox(self.von)[1] # nach oben rechts
            xe=zf.bbox(self.auf)[0]
            ID=self.erzeugeWinkelFlussSymbol(zf, x, y, xe, ye, name)
            CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
        ## "auf" liegt links unterhalb nicht ueberlagernd
        elif self.aufLinksFrei(zf.bbox(self.von),zf.bbox(self.auf)) and\
             self.aufUnter(zf.bbox(self.von),zf.bbox(self.auf)):
            bV,bA=zf.bbox(self.von),zf.bbox(self.auf)
            x,y=bV[0]+20,bV[3]
            xe,ye=bA[2]-20,bA[1]
            ID=self.erzeugeFlussSenkrecht(zf, x, y, xe, ye, name)
            CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
        ## "auf" liegt links oberhalb nicht ueberlagernd
        elif self.aufLinksFrei(zf.bbox(self.von),zf.bbox(self.auf)) and\
             self.aufUeber(zf.bbox(self.von),zf.bbox(self.auf)):
            bV,bA=zf.bbox(self.von),zf.bbox(self.auf)
            x,y=bV[0]+20,bV[1]
            xe,ye=bA[2]-20,bA[3]
            ID=self.erzeugeFlussSenkrecht(zf, x, y, xe, ye, name)
            CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)


        ## Doppelwinkel fuer rueckwaerts
        elif (x>xe):
            bV,bA=zf.bbox(self.von),zf.bbox(self.auf)
            x,y=(bV[0]+bV[2])/2,bV[1]
            xe,ye=(bA[0]+bA[2])/2,bA[1]
            ID=self.erzeugeDWFlussSymbol(zf, x, y, xe, ye, name)
            CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)
         # Notfall-"Loesung" einfach
        else:
            ID=self.erzeugeFlussSymbol(zf, x, y, xe, ye, name)
            CanvasElement.__init__(self, zf, ID, (x,y), (xe,ye), name)

    def SetzeQuelleSenke(self, quelleSenke):
        '''das Objekt sichern beim Aktualisieren des Flusses'''
        self.quelleSenke=quelleSenke

    def GibQuelleSenke(self):
        return self.quelleSenke

    def aufRechtsDeckend(self, boxVon, boxAuf):
        vx1,vy1,vx2,vy2=boxVon
        ax1,ay1,ax2,ay2=boxAuf
        return (vx1<=ax1) and (vx2>ax1) # nach rechts verschoben

    def aufLinksDeckend(self, boxVon, boxAuf):
        vx1,vy1,vx2,vy2=boxVon
        ax1,ay1,ax2,ay2=boxAuf
        return (ax1<=vx1) and (ax2>vx1) # verschoben

    def aufLinksFrei(self, boxVon, boxAuf):
        vx1,vy1,vx2,vy2=boxVon
        ax1,ay1,ax2,ay2=boxAuf
        return (ax1<=vx1) and (ax2<=vx1) # verschoben

    def aufUnter(self, boxVon, boxAuf):
        vx1,vy1,vx2,vy2=boxVon
        ax1,ay1,ax2,ay2=boxAuf
        return vy2<ay1
        
    def aufUeber(self, boxVon, boxAuf):
        vx1,vy1,vx2,vy2=boxVon
        ax1,ay1,ax2,ay2=boxAuf
        return ay2<vy1
        
    def erzeugeFlussSymbol(self, zf, x, y, xe, ye, name):
        '''x, y, xe, ye, name'''
        a,d=3,10 # Linienabstand, Spitzenweite
        pfeilDaten=x,y-a,xe-d,y-a,xe-d,y-a-d,xe,y,xe-d,y+a+d,xe-d,y+a,x,y+a
        pfeil_id=zf.create_line(pfeilDaten,width=2,tag=name,fill=self.FG())
        return self.erzeugeVentil(zf, (x+xe)/2-12, y, name)        
    
    def erzeugeWinkelFlussSymbol(self, zf, x, y, xe, ye, name):
        '''x, y Start, xe,ye Ende'''
        a,d=3,10 # Linienabstand, Spitzenweite
        if (x<xe) and (y>ye): # nach rechts oben:
            pfeilDaten=(x-a,y,
                        x-a,ye-a,
                        xe-d,ye-a,
                        xe-d,ye-a-d,
                        xe,ye,
                        xe-d,ye+a+d,
                        xe-d,ye+a,
                        x+a,ye+a,
                        x+a,y)
        elif (x<xe) and (y<=ye): # nach rechts unten:
            pfeilDaten=(x-a,y,
                        x-a,ye+a,
                        xe-d,ye+a,
                        xe-d,ye+a+d,
                        xe,ye,
                        xe-d,ye-a-d,
                        xe-d,ye-a,
                        x+a,ye-a,
                        x+a,y)
        pfeil_id=zf.create_line(pfeilDaten,width=2,tag=name,fill=self.FG())
        return self.erzeugeVentil(zf, (x+xe)/2-12, ye, name)

    def erzeugeDWFlussSymbol(self, zf, x, y, xe, ye, name):
        '''x, y, xe, ye, name'''
        a,d=3,10 # Linienabstand, Spitzenweite
        l=80
        pfeilDaten=(x-a,y,
                    x-a,y-l+a,
                    xe+a,y-l+a,
                    xe+a,ye-d,
                    xe+a+d,ye-d,
                    xe,ye,
                    xe-a-d,ye-d,
                    xe-a,ye-d,
                    xe-a,y-l-a,
                    x+a,y-l-a,
                    x+a,y)
        pfeil_id=zf.create_line(pfeilDaten,width=2,tag=name,fill=self.FG())
        return self.erzeugeVentil(zf, (x+xe)/2-12, y-l, name)        
    
    def erzeugeFlussSenkrecht(self, zf, x, y, xe, ye, name):
        '''x, y, xe, ye, name'''
        a,d=3,10 # Linienabstand, Spitzenweite
        if xe<x: k=-1  # Korrektur fuer nach links
        else:  k=1
        if ye<y: rk=-1  # Korrektur fuer nach oben
        else:  rk=1
        ym=(y+ye)/2
        pfeilDaten=(x-k*rk*a,y,
                    x-k*rk*a,ym+a,
                    xe-k*rk*a,ym+a,
                    xe-k*rk*a,ye-rk*d,
                    xe-k*rk*a-k*rk*d,ye-rk*d,
                    xe,ye,
                    xe+k*rk*a+k*rk*d,ye-rk*d,
                    xe+k*rk*a,ye-rk*d,
                    xe+k*rk*a,ym-a,
                    x+k*rk*a,ym-a,
                    x+k*rk*a,y)
        pfeil_id=zf.create_line(pfeilDaten,width=2,tag=name,fill=self.FG())
        return self.erzeugeVentil(zf, (x+xe)/2-12, (y+ye)/2, name)        

    def erzeugeVentil(self, zf, x, y, name, r=12):
        '''hier wird auch der Text erzeugt'''
        ## Elemente:
        kreis_id=zf.create_oval(x,y,x+2*r,y+2*r,tag=name,width=2,
                                fill=CanvasElement.farben[3],
                                outline=self.FG())
        rechteck_id=zf.create_rectangle(x+0.3*r,y-0.9*r,x+1.7*r,y-0.6*r,
                                        tag=name,width=2,
                                        outline=self.FG())
        ventil_id1=zf.create_line(x+r,y-0.6*r,x+r,y,tag=name,width=3,
                                  fill=self.FG())
        if name!=None:
            xt,yt=x+r, y+3*r
            self.textID=zf.create_text(xt,yt, text=name, tag=name,
                                       fill=self.FG(),
                                       font="Sans 11 bold")
        self.ventil_id=kreis_id
        return kreis_id
    
    def GibVentil_id(self):
        return self.ventil_id

    def gibQuelleSenke(self):
        '''gibt entweder das Quelle- , das Senke-Element oder None zurueck'''
        return self.quelleSenke
                
    def GibVonAuf(self):
        return self.von,self.auf
    
    def UpdateNamen(self, von, auf):
        self.von,self.auf=von, auf

class QuelleSenke(CanvasElement):
    def __init__(self, zf, name, x, y, istQuelle=True):
        '''Quelle oder Senke sind an einen Fluss gebunden'''
        r=8
        if istQuelle: dx=-r-r/2+4
        else: dx=r+r/2+4
        b1_id=zf.create_arc(x+dx-2*r,y-2*r,x+dx,y, start=0, extent=210,width=2, tag=name,style=ARC,outline=self.FG())
        b2_id=zf.create_arc(x+dx-r,y-2*r,x+dx+r,y, start=270, extent=210,width=2, tag=name,style=ARC,outline=self.FG())
        b3_id=zf.create_arc(x+dx-2*r,y-r,x+dx,y+r, start=90, extent=210,width=2, tag=name,style=ARC,outline=self.FG())
        b4_id=zf.create_arc(x+dx-r,y-r,x+dx+r,y+r, start=180, extent=210,width=2, tag=name,style=ARC,outline=self.FG())
        ID=b1_id
        if istQuelle: zf.addtag_withtag('Quelle_'+name, ID)
        else: zf.addtag_withtag('Senke_'+name, ID)
        CanvasElement.__init__(self, zf, ID, (x-r,y-r), (x+r,y+r), name)
        
